#! /bin/sh
# ppgen-rand: extract bits from the system entropy pool.
# Copyright (C) 2003 Raphael Poss <ppgen@raphael.poss.name>

{ 
  expr "$1" : "[0-9][0-9]*$" &&
  expr "$2" : "[0-9][0-9]*$" 
} >/dev/null 2>&1 || {
  echo "usage: $0 <n> <p>"
  echo " <n> : number of output numbers"
  echo " <p> : number of 8-bit random chunks in each output number"
  echo
  echo "Warning: <n> is limited by the size of the integers"
  echo "that the \"expr\" command can handle (typically 4 or 8)."
  exit 1
} >&2

DUMP_SCRIPT=/usr/share/ppgen/dump.awk

i=$1
while [ $i -gt 0 ]; do
  res=0
  numbers=`dd if=/dev/random bs=1 count=$2 2>/dev/null | \
     gawk -f "$DUMP_SCRIPT" | \
     cut -d' ' -f1`

  for n in $numbers; do
    res=`expr $res \* 255 + $n`
  done
  echo $res
  i=`expr $i - 1`
done

exit 0

